function AtJsMenuLoader() {
	this.AtJsMenuBasePath = '';
	this.sourceData = '';
	this.parser = null;
	this.onready = function() {};
}

AtJsMenuLoader._headElm = null;
AtJsMenuLoader.currentLoader = null;
AtJsMenuLoader.__scripts__ = ['browser','AtJsMenuKeys','compat','AtJsMenu','AtJsMenuXmlDataset','xmlCompat',
	'AtJsMenuRemoteXmlDataset'];
AtJsMenuLoader.__scriptsLoaded__ = {
	browser: false,
	AtJsMenuKeys: false,
	compat: false,
	AtJsMenu: false,
	AtJsMenuXmlDataset: false,
	xmlCompat: false,
	AtJsMenuRemoteXmlDataset: false
};
AtJsMenuLoader.__scriptsGetName__ = {
	compat: function() {return 'compat-'+navigator.family+'.js';},
	xmlCompat: function() {return ((navigator.family=='IE6') ? 'xmlCompat-IE6.js' : 'xmlCompat-Gecko.js');}
};

AtJsMenuLoader.createScriptElement = function(sName) {
	var oScript = document.createElement('SCRIPT');
	oScript.setAttribute('languange','JavaScript');
	oScript.setAttribute('type','text/javascript');
	if (AtJsMenuLoader.__scriptsGetName__[sName]) sName = AtJsMenuLoader.__scriptsGetName__[sName]();
	else sName += '.js';
	oScript.setAttribute('src', AtJsMenuLoader.currentLoader.AtJsMenuBasePath + sName);
	return oScript;
}

AtJsMenuLoader.setScriptLoadedCallBack = function(oScript,idxScript) {
	if (navigator.family != 'IE6') {
		oScript.onload = new Function(
			"AtJsMenuLoader.__scriptsLoaded__[ AtJsMenuLoader.__scripts__["+idxScript+"] ] = true; "
			+"AtJsMenuLoader.loadScript(" + (idxScript+1) + ");"
		);
	}  else {
		oScript.onreadystatechange = new Function(""
			+"if (this.readyState == 'complete' || this.readyState == 'loaded') { "
			+"AtJsMenuLoader.__scriptsLoaded__[ AtJsMenuLoader.__scripts__["+idxScript+"] ] = true; "
			+"AtJsMenuLoader.loadScript(" + (idxScript+1) + "); }" 
		);
	}
}

AtJsMenuLoader.loadSource = function() {
	if (this.parser) return;
	var oLoader = AtJsMenuLoader.currentLoader;
	this.parser = new AtJsMenuRemoteXmlDataset(oLoader.sourceData, oLoader.onready);
}

AtJsMenuLoader.loadScript = function(idxScript) {
	var arScr = AtJsMenuLoader.__scripts__;
	if (idxScript >= arScr.length) return AtJsMenuLoader.loadSource();
	var sName = arScr[idxScript];
	while (AtJsMenuLoader.__scriptsLoaded__[sName]) {
		idxScript++;
		if (idxScript >= arScr.length) return AtJsMenuLoader.loadSource();
		sName = arScr[idxScript];
	}
	var oScript = AtJsMenuLoader.createScriptElement(sName);
	AtJsMenuLoader.setScriptLoadedCallBack(oScript,idxScript);
	AtJsMenuLoader._headElm.appendChild(oScript);
}

AtJsMenuLoader.prototype.load = function() {
	if (!this.sourceData) return;
	this.parser = null;
	AtJsMenuLoader.currentLoader = this;
	
	var sPath = (this.AtJsMenuBasePath+'').replace(/^\s+/,'').replace(/\s+$/,'');
	if (sPath != '' && sPath.charAt(sPath.length-1) != '/') sPath = sPath + '/';
	this.AtJsMenuBasePath = sPath;
	
	if (!AtJsMenuLoader._headElm) {
		var oHTML = document.documentElement, arHeads = oHTML.getElementsByTagName('HEAD');
		AtJsMenuLoader._headElm = (arHeads.length ? arHeads[0] : null);
		if (!AtJsMenuLoader._headElm)
			AtJsMenuLoader._headElm = oHTML.insertBefore(document.createElement('HEAD'),
				oHTML.childNodes[0]);
	}
	
	if (!AtJsMenuLoader.__scriptsLoaded__.browser) {
		var oScript = AtJsMenuLoader.createScriptElement('browser');
		oScript.onload = function() {
			AtJsMenuLoader.__scriptsLoaded__.browser = true;
			AtJsMenuLoader.currentLoader.load();
		};
		oScript.onreadystatechange = function() {
			if (this.readyState == 'complete' || this.readyState == 'loaded') {
				AtJsMenuLoader.__scriptsLoaded__.browser = true;
				AtJsMenuLoader.currentLoader.load();
			}
		};
		AtJsMenuLoader._headElm.appendChild(oScript);
		return;
	}
	AtJsMenuLoader.loadScript(1);
}