/*	Distributed as part of 'AT JsMenu' under the same terms (LGPL)
	Author: AT Mulyana (atmulyana@yahoo.com)
	Copyright (C) 2001-2006 AT Mulyana
*/
function AtJsMenuXmlDataset(sId) {
	this._buttonGroups = {};
	this._scripts = [];
	this._inlineScripts = [];
	this.source = sId;
	if (!AtJsMenuXmlDataset.prototype._headElm) {
		var oHTML = document.documentElement, arHeads = oHTML.getElementsByTagName('HEAD');
		AtJsMenuXmlDataset.prototype._headElm = (arHeads.length ? arHeads[0] : null);
		if (!AtJsMenuXmlDataset.prototype._headElm)
			AtJsMenuXmlDataset.prototype._headElm = oHTML.insertBefore(document.createElement('HEAD'),
				oHTML.childNodes[0]);
	}
	if (sId) this.parse();
}
AtJsMenuXmlDataset.prototype = {
_headElm: null,
strip: function(sValue) {
	if (!sValue) return '';
	return (sValue+'').replace(/^\s+/,'').replace(/\s+$/,'');
},
getFirstChildElementOf: function(oElm) {
	for (var i=0; i<oElm.childNodes.length; i++)
		if (oElm.childNodes[i].nodeType == 1) return oElm.childNodes[i];
	return null;
},
insertElementInHead: function(sTag,arAttributes) {
	var oElm = document.createElement(sTag);
	for (var i=0; i<arAttributes.length; i++) if (arAttributes[i].nodeName!='name')
		oElm.setAttribute(arAttributes[i].nodeName, arAttributes[i].nodeValue);
	this._headElm.appendChild(oElm);
},
insertLink: function(oLinkElm) {
	this.insertElementInHead('LINK',oLinkElm.attributes);
},
insertScript: function(oScriptElm) {
	this.insertElementInHead('SCRIPT',oScriptElm.attributes);
},
setDescriptionOf: function(oMenu,sDesc,sDescAttrName) {
	if (sDesc) oMenu.description = sDesc;
	if (sDescAttrName) oMenu.descAttrName = sDescAttrName;
},
getIcon: function(sIconSrc,sIconType) {
	if (sIconType == 'cssclass') {
		var oIcon = document.createElement('DIV');
		oIcon.className = sIconSrc;
		return oIcon;
	}
	if (sIconSrc) return sIconSrc;
	return null;
},
setEventHandlerOf: function(sEvent,oMenu,sHandlerStatements) {
	if (sHandlerStatements) oMenu[sEvent] = new Function("e",sHandlerStatements);
},
setRadioGroupValue: function() {
	for (sName in this._buttonGroups) {
		var oButtonGroup = this._buttonGroups[sName];
		oButtonGroup.setRequestParam(new AtJsMenuRequestParam(sName));
		if (oButtonGroup.getRequestParamValue()!==null) oButtonGroup.setValueFromRequestParam();
		if (AtJsMenuRequestParam.isExist) oButtonGroup.setValueFromRequestParam();
		else oButtonGroup.setRequestParamValue(oButtonGroup.getValue());
	}
},
createSign: function(oElm) {
	var oSign = document.createElement(oElm.tagName.substr(1));
	var arNodes = oElm.attributes;
	for (var i=0; i<arNodes.length; i++)
		if (arNodes[i].nodeName.toLowerCase()!='class')
			oSign.setAttribute(arNodes[i].nodeName, arNodes[i].nodeValue);
		else
			oSign.className = arNodes[i].nodeValue; //specially for IE
	arNodes = oElm.childNodes;
	for (var i=0; i<arNodes.length; i++) {
		if (arNodes[i].nodeType == 1) oSign.appendChild(this.createSign(arNodes[i]));
		else if (arNodes[i].nodeType == 3) oSign.appendChild(document.createTextNode(arNodes[i].nodeValue));
	}
	return oSign;
},
createMenuItem: function(oElm,bHasChild) {
	var arAttributes = oElm.attributes, sIconSrc,sIconType,sText,sVarName,sDesc,sDescAttrName,
		sOnclick,sOnchange,sType,bSelected=false,bDisabled=false,sName,sValue,oMenuItem,sMnemonic,
		sAccelerator,iModifiers=0,adtProps={};
	for (var i=0; i<arAttributes.length; i++) {
		var sAttrVal = this.strip(arAttributes[i].nodeValue);
		switch (arAttributes[i].nodeName.toLowerCase()) {
			case 'icon': sIconSrc = sAttrVal; break;
			case 'icontype': sIconType = sAttrVal.toLowerCase(); break;
			case 'text': case 'label': sText = sAttrVal; break;
			case 'varname': sVarName = sAttrVal; break;
			case 'description': sDesc = sAttrVal; break;
			case 'descattrname': sDescAttrName = sAttrVal; break;
			case 'onclick': case 'evclick': sOnclick = sAttrVal; break;
			case 'onchange': case 'evchange': sOnchange = sAttrVal; break;
			case 'type': sType = sAttrVal.toLowerCase(); break;
			case 'mnemonic':
				if (sAttrVal.length == 1 && AtJsMenuKeys) {
					sAttrVal = sAttrVal.toUpperCase();
					if (sAttrVal >= 'A' && sAttrVal <= 'Z' || sAttrVal >= '0' && sAttrVal <= '9')
						sMnemonic = 'DOM_VK_'+sAttrVal;
				}
				break;
			case 'accelerator':
				if (sAttrVal && AtJsMenuKeys) {
					var arKeys = sAttrVal.toUpperCase().split(/\s*\+\s*/);
					sAccelerator = arKeys[arKeys.length-1].replace(/\s+/g,'_');
					for (var j=0; j<arKeys.length-1; j++) {
						if (arKeys[j]=='ALT') iModifiers += AtJsMenuKeys.ALT_MASK;
						else if (arKeys[j]=='CTRL') iModifiers += AtJsMenuKeys.CONTROL_MASK;
						else if (arKeys[j]=='SHIFT') iModifiers += AtJsMenuKeys.SHIFT_MASK;
					}
				}
				break;
			case 'isdisabled': bDisabled = (eval(sAttrVal) != ''); break;
			case 'selected': case 'isselected': bSelected = (eval(sAttrVal) != ''); break;
			case 'name': sName = sAttrVal; break;
			case 'value': sValue = sAttrVal; break;
			default: adtProps[ arAttributes[i].nodeName ] = sAttrVal;
		}
	}
	
	var icon = this.getIcon(sIconSrc,sIconType);
	if (sType == 'checkbox' || sType == 'check') {
		oMenuItem = new AtJsMenuCheckBoxItem(sText,icon,bSelected);
		if (sName) {
			oMenuItem.setRequestParam(new AtJsMenuRequestParam(sName));
			oMenuItem.value = (sValue ? sValue : '');
			if (AtJsMenuRequestParam.isExist) oMenuItem.setValueFromRequestParam();
			else if (oMenuItem.isSelected()) oMenuItem.setRequestParamValue(oMenuItem.value);
		}
	} else if (sType == 'radio') {
		oMenuItem = new AtJsMenuRadioButtonItem(sText,icon,bSelected,sValue);
		if (!this._buttonGroups[sName])
			var oButtonGroup = this._buttonGroups[sName] = new AtJsMenuButtonGroup();
		else
			var oButtonGroup = this._buttonGroups[sName];
		oButtonGroup.add(oMenuItem);
	} else if (bHasChild) {
		oMenuItem = new AtJsMenu(sText,icon);
	} else {
		sOnchange = '';
		oMenuItem = new AtJsMenuItem(sText,icon);
	}
	
	if (bDisabled) oMenuItem.setEnabled(false);
	if (sMnemonic) oMenuItem.setMnemonic(AtJsMenuKeys[sMnemonic]);
	if (sAccelerator) oMenuItem.setAccelerator(AtJsMenuKeys['DOM_VK_'+sAccelerator],iModifiers);
	this.setDescriptionOf(oMenuItem,sDesc,sDescAttrName);
	this.setEventHandlerOf('onclick',oMenuItem,sOnclick);
	this.setEventHandlerOf('onchange',oMenuItem,sOnchange);
	for (p in adtProps) oMenuItem[p] = adtProps[p];
	if (sVarName) window[sVarName] = oMenuItem;
	return oMenuItem;
},
createMenuListOf: function(oElm,oParentMenu) {
	var arChildren = oElm.childNodes;
	for (var i=0; i<arChildren.length; i++) {
		if (arChildren[i].nodeType != 1) continue; //not element node
		var sElmName = arChildren[i].nodeName.toLowerCase();
		if (sElmName == 'menuitem') oParentMenu.add( this.createMenuItem(arChildren[i]) );
		else if (sElmName == 'separator') oParentMenu.addSeparator();
		else if (sElmName == 'menudir') {
			var oMenu = this.createMenuItem(arChildren[i],true);
			oParentMenu.add(oMenu);
			this.createMenuListOf(arChildren[i],oMenu);
		}
	}
},
createMenuBar: function(oElm) {
	var icon = this.getIcon(oElm.getAttribute('icon'),oElm.getAttribute('icontype'));
	var sId = oElm.getAttribute('contid');
	var oMenuBar = new AtJsMenuBar(sId,icon);
	this.createMenuListOf(oElm,oMenuBar);
	var sVarName = this.strip(oElm.getAttribute('varname'));
	if (sVarName) window[sVarName] = oMenuBar;
	return oMenuBar;
},
createPopup: function(oElm) {
	var oPopup = new  AtJsMenuPopup();
	this.createMenuListOf(oElm,oPopup);
	var sVarName = this.strip(oElm.getAttribute('varname'));
	if (sVarName) window[sVarName] = oPopup;
	return oPopup;
},
parse: function() {
	var oRoot = this.getRootElement();
	if (!oRoot) return;
	
	var arAttributes = oRoot.attributes;
	for (var i=0; i<arAttributes.length; i++) {
		var sValue = this.strip(arAttributes[i].nodeValue);
		switch (arAttributes[i].nodeName.toLowerCase()) {
			case 'delayopen':
				AtJsMenu.delayOpen = parseInt(sValue);
				if (isNaN(AtJsMenu.delayOpen)) AtJsMenu.delayOpen = 0;
				break;
			case 'chunkpersizeopen':
				AtJsMenu.chunkPerSizeOpen = parseInt(sValue);
				if (isNaN(AtJsMenu.chunkPerSizeOpen)) AtJsMenu.chunkPerSizeOpen = 5;
				break;
			case 'zindexmin': AtJsMenu.setZIndexMin(sValue); break;
			case 'cookiedisabled': AtJsMenuRequestParam.isCookieEnabled = false; break;
			case 'onclick': case 'evclick': this.setEventHandlerOf('onclick',AtJsMenu,sValue);
			case 'onchange': case 'evchange': this.setEventHandlerOf('onchange',AtJsMenu,sValue);
		}
	}
	
	var arNode = oRoot.childNodes;
	for (var i=0; i<arNode.length; i++) {
		var oNode = arNode[i];
		if (oNode.nodeType != 1) continue; //not element node
		switch (oNode.nodeName.toLowerCase()) {
			case 'menubar': this.createMenuBar(oNode); break;
			case 'popup': this.createPopup(oNode); break;
			case 'atjsmenulink': this.insertLink(oNode); break;
			case 'atjsmenuscript':
				if (oNode.getAttributeNode('later')===null) this.insertScript(oNode);
				else {
					var oScript = document.createElement('SCRIPT'), oAttr, sAttrName, hasSrc=false;
					for (var j=0; j<oNode.attributes.length; j++) {
						oAttr = oNode.attributes[j];
						sAttrName = oAttr.nodeName.toLowerCase();
						if (sAttrName=='later') continue;
						if (sAttrName=='src') hasSrc = true;
						oScript.setAttribute(sAttrName,oAttr.nodeValue);
					}
					if (hasSrc) this._scripts[this._scripts.length] = oScript;
					else for (j=0; j<oNode.childNodes.length; j++)
						if (oNode.childNodes[j].nodeType==8) //comment node
							this._inlineScripts.push(oNode.childNodes[j].nodeValue);
				}
				break;
				this.insertScript(oNode); break;
			case 'subsign':
				var oSign = this.createSign(this.getFirstChildElementOf(oNode));
				if (oSign) AtJsMenu.setSubSign(oSign);
				break;
			case 'checksign':
				var oSign = this.createSign(this.getFirstChildElementOf(oNode));
				if (oSign) AtJsMenu.setCheckSign(oSign);
				break;
			case 'radiosign':
				var oSign = this.createSign(this.getFirstChildElementOf(oNode));
				if (oSign) AtJsMenu.setRadioSign(oSign);
				break;
			case 'horizontalseparatorsign':
				var oSign = this.createSign(this.getFirstChildElementOf(oNode));
				if (oSign) AtJsMenu.setHorizontalSeparatorSign(oSign);
				break;
			case 'verticalseparatorsign':
				var oSign = this.createSign(this.getFirstChildElementOf(oNode));
				if (oSign) AtJsMenu.setVerticalSeparatorSign(oSign);
				break;
		}
	}

	this.setRadioGroupValue();
	for (i=0; i < this._scripts.length; i++) document.body.appendChild(this._scripts[i]);
	for (i=0; i < this._inlineScripts.length; i++) {
		eval(this._inlineScripts[i]);
	}
}
}