/*
	Distributed as part of 'AT JsMenu' under the same terms (LGPL)
	Author: AT Mulyana (atmulyana@yahoo.com)
	Copyright (C) 2001-2006 AT Mulyana
*/

//Makes the event object in Gecko like the one in IE
Event.prototype.srcElement getter= function() {
	return this.target;
}
Event.prototype.fromElement getter= function() {
	return this.relatedTarget;
}
Event.prototype.toElement getter= function() {
	return this.relatedTarget;
}
Event.prototype.returnValue setter= function(bVal) {
	if (!bVal) this.preventDefault();
}
Event.prototype.cancelBubble setter= function(bVal) {
	if (bVal) this.stopPropagation();
}
Event.prototype.offsetX getter= function() {
	return this.layerX;
}
Event.prototype.offsetY getter= function() {
	return this.layerY;
}
	
//Uniforms the value of mouse button when a mouse event happens
Event.prototype.getButton = function() {
	switch (this.which) {
		case 1: return 1; //left
		case 2: return 4; //middle
		case 3: return 2; //right
		default: return 0;
	}
}

//Emulates method contains in IE
Element.prototype.contains = function(oNode) {
	while (oNode) {
		if (this == oNode) return true;
		try {
			oNode = oNode.parentNode;
		} catch(e) {
			return false;
		}
	}
	return false;
}

//Window area side coords
function getWinLeftSide() {
	return window.pageXOffset;
}
function getWinRightSide() {
	return getWinLeftSide() + window.innerWidth - 1;
}
function getWinTopSide() {
	return window.pageYOffset;
}
function getWinBottomSide() {
	return getWinTopSide() + window.innerHeight - 1;
}

function getElementCoordOnPage(oElm, iBL, iBT) {
	var oCS = document.defaultView.getComputedStyle(oElm, '');
	var iX = 0, iY = 0, iPBL = 0, iPBT = 0;
	if (oCS.getPropertyValue("position") != "") { //Mozilla 1+
		while (oElm) {
			iX += oElm.offsetLeft + iPBL;
			iY += oElm.offsetTop + iPBT;
			var sPos = oCS.getPropertyValue("position");
			oElm = oElm.offsetParent;
			oCS = document.defaultView.getComputedStyle(oElm, '');
			iPBL = parseFloat(oCS.getPropertyValue("border-left-width"));
			iPBL = (isNaN(iPBL)? 0 : Math.round(iPBL));
			iPBT = parseFloat(oCS.getPropertyValue("border-top-width"));
			iPBT = (isNaN(iPBT)? 0 : Math.round(iPBT));
			if (oElm == document.body) {
				if (sPos != "absolute") {
					iX -= oElm.offsetLeft;
					iY -= oElm.offsetTop;
				}
				break;
			}
		}
		return {x: iX, y: iY};
	}

	if (typeof iBL != "number") {
		iBL = parseFloat(oCS.getPropertyValue("border-left-width"));
		iBL = (isNaN(iBL)? 0 : Math.round(iBL));
	}
	if (typeof iBT != "number") {
		iBT = parseFloat(oCS.getPropertyValue("border-top-width"));
		iBT = (isNaN(iBT)? 0 : Math.round(iBT));
	}
	
	while (true) {
		if (oElm == document.body) break;
		var iL = Math.round(parseFloat(oCS.getPropertyValue("left")));
		var iT = Math.round(parseFloat(oCS.getPropertyValue("top")));
		iX += iL - iBL;
		iY += iT - iBT;
		
		var iOL = oElm.offsetLeft;
		iBL = parseFloat(oCS.getPropertyValue("border-left-width"));
		iBL = (isNaN(iBL)? 0 : Math.round(iBL));
		oElm = oElm.offsetParent;
		if (!oElm) break;
		oCS = document.defaultView.getComputedStyle(oElm, '');
		iPBL = parseFloat(oCS.getPropertyValue("border-left-width"));
		iPBL = (isNaN(iPBL)? 0 : Math.round(iPBL));
		iPBT = parseFloat(oCS.getPropertyValue("border-top-width"));
		iPBT = (isNaN(iPBT)? 0 : Math.round(iPBT));
		if (iOL + iBL + iPBL != iL) break;
		iBL = iPBL; iBT = iPBT;
	}
	return {x: iX, y: iY};
}

function setNotSelectedElement(oElm) {
	if (typeof oElm.onmousedown == 'function') oElm._onmousedown = oElm.onmousedown;
	else oElm._onmousedown = function() {};
	oElm.onmousedown = function(e) { oElm._onmousedown(e); return false; };
}
