/*
	Distributed as part of 'AT JsMenu' under the same terms (LGPL)
	Author: AT Mulyana (atmulyana@yahoo.com)
	Copyright (C) 2001-2006 AT Mulyana
*/

document.addEventListener = function(sEventType, fnListener, bUseCapture) {
	sEventType = 'on' + (sEventType+'').toLowerCase();
	this.attachEvent(sEventType, fnListener);
}

function AtJsMenuEvent() {
	//Uniforms the value of mouse button when a mouse event happens
	var e = window.event;
	e.getButton = function() {
		return this.button;
	};
	return e;
}

//Window area side coords
if (document.compatMode == 'CSS1Compat') {
	window.getWinLeftSide = function() {
		return document.documentElement.scrollLeft;
	}
	window.getWinRightSide = function() {
		return getWinLeftSide() + document.documentElement.clientWidth - 1;
	}
	window.getWinTopSide = function() {
		return document.documentElement.scrollTop;
	}
	window.getWinBottomSide = function() {
		return getWinTopSide() + document.documentElement.clientHeight - 1;
	}
} else {
	window.getWinLeftSide = function() {
		return document.body.scrollLeft;
	}
	window.getWinRightSide = function() {
		return getWinLeftSide() + document.body.clientWidth - 1;
	}
	window.getWinTopSide = function() {
		return document.body.scrollTop;
	}
	window.getWinBottomSide = function() {
		return getWinTopSide() + document.body.clientHeight - 1;
	}
}

function getElementCoordOnPage(oElm) {
	var iX = oElm.offsetLeft, iY = oElm.offsetTop;
	while ((oElm.offsetParent != document.body) && (oElm.offsetParent.tagName != "HTML")) {
		oElm = oElm.offsetParent;
		iX += oElm.offsetLeft;
		iY += oElm.offsetTop;
		if (oElm.tagName!="TABLE") {
			iX += oElm.clientLeft;
			iY += oElm.clientTop;
		}
	}
	return {x: iX, y: iY};
}

function setNotSelectedElement(oElm) {
	oElm.onselectstart = function() { window.event.returnValue = false; };
}
